## mingw-w64-qt6-quick3d-6.9.0-1.src.tar.zst

=== src/effects/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## qtquick3deffectplugin Plugin:
#####################################################################

set(qml_files
    "Vignette.qml"
    "TiltShift.qml"
    "SCurveTonemap.qml"
    "Scatter.qml"
    "MotionBlur.qml"
    "HDRBloomTonemap.qml"
    "GaussianBlur.qml"
    "Fxaa.qml"
    "Flip.qml"
    "Emboss.qml"
    "EdgeDetect.qml"
    "DistortionSpiral.qml"
    "DistortionSphere.qml"
    "DistortionRipple.qml"
    "Desaturate.qml"
    "DepthOfFieldHQBlur.qml"
    "ColorMaster.qml"
    "ChromaticAberration.qml"
    "BrushStrokes.qml"
    "Blur.qml"
    "AdditiveColorGradient.qml"
)

qt_internal_add_qml_module(Quick3DEffects
    URI "QtQuick3D.Effects"
    VERSION "${PROJECT_VERSION}"
    DESIGNER_SUPPORTED
    CLASS_NAME QtQuick3DEffectPlugin
    PLUGIN_TARGET qtquick3deffectplugin
    DEPENDENCIES
        QtQuick3D/auto
        QtQuick.Window/auto
    NO_SYNC_QT
    QML_FILES
        ${qml_files}
    PUBLIC_LIBRARIES
        Qt::Qml
        Qt::Quick
        Qt::Quick3DPrivate
)

# Resources:
set(qteffectlibrary_resource_files
    "maps/brushnoise.png"
    "maps/white.png"
    "shaders/additivecolorgradient.frag"
    "shaders/blend.frag"
    "shaders/blur.frag"
    "shaders/blurhorizontal.vert"
    "shaders/blurvertical.vert"
    "shaders/brushstrokes.frag"
    "shaders/chromaticaberration.frag"
    "shaders/colormaster.frag"
    "shaders/combiner.frag"
    "shaders/depthoffieldblur.frag"
    "shaders/depthoffieldblur.vert"
    "shaders/desaturate.frag"
    "shaders/distortion.vert"
    "shaders/distortionripple.frag"
    "shaders/distortionsphere.frag"
    "shaders/distortionspiral.frag"
    "shaders/downsample.frag"
    "shaders/downsample.vert"
    "shaders/downsampletiltshift.frag"
    "shaders/edgedetect.frag"
    "shaders/edgedetect.vert"
    "shaders/emboss.frag"
    "shaders/flip.frag"
    "shaders/fxaaBlur.frag"
    "shaders/fxaaRgbl.frag"
    "shaders/gaussianblur.frag"
    "shaders/luminosity.frag"
    "shaders/luminosity.vert"
    "shaders/motionblurhorizontal.frag"
    "shaders/motionblurhorizontal.vert"
    "shaders/motionblurvertical.frag"
    "shaders/motionblurvertical.vert"
    "shaders/poissonblur.frag"
    "shaders/poissonblur.vert"
    "shaders/poissonblurtiltshift.frag"
    "shaders/poissonblurtiltshift.vert"
    "shaders/scatter.frag"
    "shaders/scurvetonemap.frag"
    "shaders/vignette.frag"
)

qt_internal_add_resource(Quick3DEffects "qteffectlibrary"
    PREFIX
        "/qtquick3deffects"
    FILES
        ${qteffectlibrary_resource_files}
)


#### Keys ignored in scope 2:.:.:plugin.pro:<TRUE>:
# CXX_MODULE = "qml"
# DISTFILES = "qmldir"
# EFFECT_IMAGE_FILES = "maps/brushnoise.png" "maps/white.png"
# OTHER_FILES = "$$QML_FILES"
# QMLTYPES_FILENAME = "plugins.qmltypes"
# QMLTYPES_INSTALL_DIR = "$$[QT_INSTALL_QML]/QtQuick3D/Effects"
# QML_FILES = "Vignette.qml" "TiltShift.qml" "SCurveTonemap.qml" "Scatter.qml" "MotionBlur.qml" "HDRBloomTonemap.qml" "GaussianBlur.qml" "Fxaa.qml" "Flip.qml" "Emboss.qml" "EdgeDetect.qml" "DistortionSpiral.qml" "DistortionSphere.qml" "DistortionRipple.qml" "Desaturate.qml" "DepthOfFieldHQBlur.qml" "ColorMaster.qml" "ChromaticAberration.qml" "BrushStrokes.qml" "Blur.qml" "AdditiveColorGradient.qml" "$$EFFECT_IMAGE_FILES"
# QML_IMPORT_NAME = "QtQuick3D.Effects"
# QML_IMPORT_VERSION = "$$QT_VERSION"
# TARGETPATH = "QtQuick3D/Effects"

## Scopes:
#####################################################################

if(QT_FEATURE_quick_designer AND QT_BUILD_SHARED_LIBS) # special case handle unconverted static
    add_subdirectory(designer)
endif()

=== examples/quick3d/hellocube/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(hellocube LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

find_package(Qt6 REQUIRED COMPONENTS Core Gui Quick Quick3D)

qt_add_executable(hellocube
    main.cpp
)

set_target_properties(hellocube PROPERTIES
    WIN32_EXECUTABLE TRUE
    MACOSX_BUNDLE TRUE
)

target_link_libraries(hellocube PUBLIC
    Qt::Core
    Qt::Gui
    Qt::Quick
    Qt::Quick3D
)

qt_add_qml_module(hellocube
    URI Example
    VERSION 1.0
    QML_FILES main.qml
    RESOURCES qt_logo.png
    NO_RESOURCE_TARGET_PATH
)

install(TARGETS hellocube
    BUNDLE  DESTINATION .
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

qt_generate_deploy_qml_app_script(
    TARGET hellocube
    OUTPUT_SCRIPT deploy_script
    MACOS_BUNDLE_POST_BUILD
    NO_UNSUPPORTED_PLATFORM_ERROR
    DEPLOY_USER_QML_MODULES_ON_UNSUPPORTED_PLATFORM
)
install(SCRIPT ${deploy_script})

=== tests/manual/stereoscopic/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_manual_test(manual_test_stereoscopic
    GUI
    SOURCES
        main.cpp
    LIBRARIES
        Qt::Gui
        Qt::Quick
        Qt::Quick3D
)

# Resources:
set(qml_resource_files
    "SceneNode.qml"
    "anaglyph.frag.qsb"
    "main.qml"
)

qt_internal_add_resource(manual_test_stereoscopic "qml"
    PREFIX
        "/"
    FILES
        ${qml_resource_files}
)

=== tests/auto/quick3d/qquick3dtexturedata/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qquick3dtexturedata.pro.

#####################################################################
## qquick3dtexturedata Test:
#####################################################################

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_qquick3dtexturedata LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_qquick3dtexturedata
    SOURCES
        tst_qquick3dtexturedata.cpp
    LIBRARIES
        Qt::Quick3DPrivate
        Qt::Quick3DRuntimeRenderPrivate
)

#### Keys ignored in scope 1:.:.:qquick3dtexturedata.pro:<TRUE>:
# TEMPLATE = "app"

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-quick3d
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.9.0
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='Qt module and API for defining 3D content in Qt Quick (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtquick3d.git"
msys2_references=(
  'archlinux: qt6-quick3d'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:GPL-3.0-only WITH Qt-GPL-exception-1.0 AND LGPL-3.0-only AND BSD-3-Clause AND GFDL-1.3-no-invariants-only AND GPL-2.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-assimp"
             "${MINGW_PACKAGE_PREFIX}-vulkan-headers"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
             "${MINGW_PACKAGE_PREFIX}-qt6-quicktimeline"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz"
        001-appending-qt6-to-remove-qt5-conflict.patch)
sha256sums=('a295268fdca5aeaab6bb4bb1a0a4d2720b19679ab5145c5185dac7ac3399e488'
            '211bb1f042bf9c0ddedb15b0e3d62b94e3b247dc96294fd92f4d8035784f1c7d')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd $srcdir/${_pkgfn}

  apply_patch_with_msg \
    001-appending-qt6-to-remove-qt5-conflict.patch

}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-quick3d() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative"
           "${MINGW_PACKAGE_PREFIX}-qt6-shadertools")
  optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-quicktimeline"
              "${MINGW_PACKAGE_PREFIX}-assimp")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs "${pkgdir}"/.${MINGW_PREFIX} "${srcdir}"/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-quick3d-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative-debug"
           "${MINGW_PACKAGE_PREFIX}-qt6-shadertools-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf "${srcdir}"/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
